<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>41.55</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>
<body>
    <div class="container">
        <h2 style="text-align: center;">Danh sách đơn hàng</h2>
       
         <div class="row form-group ">
          <div class="col-2">
            <lable class="label">Trạng thái Order</lable>
          </div>
          <div class="col-3">
            <select class="form-control" id="slt-status">
                <option value="0">All</option>
                <option value="open">Open</option>
                <option value="confirmed">Confirmed</option>
                <option value="cancel">Cancel</option>
            </select>
          </div>
          <div class="col-2">
            <label class="label">Loại Pizza</label>
          </div>
          <div class="col-3">
           <select class="form-control" id="slt-pizza-type">
                <option value="0">All</option>
                <option value="Hawaii">Hawaii</option>
                <option value="bacon">Bacon</option>
                <option value="Seafood">Seafood</option>
           </select>
          </div>
          <div class="col-2">
            <button id="btn-filter" class="btn btn-primary">Filter</button>
          </div>
          
         </div>
        
        
        <table class="table table-bordered table-striped table-hover" id="don-table">
          <thead>
            <tr>
              <th>Order code</th>
              <th>Kich cỡ Combo</th>
              <th>Loại Pizza</th>
              <th>Nước Uống</th>
              <th>Thành Tiền</th>
              <th>Họ và tên</th>
              <th>số điện thoại</th>
              <th>Trạng thái</th>
              <th>Chi tiết</th>
            </tr>
        </table>
      </div>

      <!-- define a update modal -->
      <div class="modal" tabindex="-1" role="dialog" id="update-modal">
        <!-- <form id="form-update"> -->
         <div class="modal-dialog" role="document">
           <div class="modal-content">
            <!-- modal header  -->
             <div class="modal-header bg-light">
               <h5 class="modal-title">Update Đơn Hàng</h5>
               <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                 <span aria-hidden="true">&times;</span>
               </button>
             </div>
             <!-- modal body  -->
            <div class="modal-body bg-success form-group">

              <div class="row form-group">
                 <div class="col-3">
                  <label class="label">Order Code</label>
                 </div>
                 <div class="col-9">
                  <input id="inp-ordercode" class="form-control" required>
                 </div>
              </div>   
              
              <div class="row form-group">
                <div class="col-3">
                 <label class="label">Size</label>
                </div>
                <div class="col-9">
                  <select id="slt-size" class="form-control">
                    <option value="S">size S</option>
                    <option value="M">size M</option>
                    <option value="L">size L</option>
                  </select>
                </div>
             </div>   

             <div class="row form-group">
                <div class="col-3">
                <label class="label">Đường kính</label>
                </div>
                <div class="col-9">
                  <input id="inp-duong-kinh" class="form-control" required>
                </div>
              </div>   
              
              <div class="row form-group">
                <div class="col-3">
                <label class="label">Sườn Nướng</label>
                </div>
                <div class="col-9">
                  <input id="inp-suon" type="number" class="form-control" required>
                </div>
              </div>   
              
              <div class="row form-group">
                <div class="col-3">
                <label class="label">Salad</label>
                </div>
                <div class="col-9">
                  <input type="number" id="inp-salad" class="form-control" required>
                </div>
              </div>   

              <div class="row form-group">
                <div class="col-3">
                <label class="label">Pizza Type</label>
                </div>
                <div class="col-9">
                  <input id="inp-pizza-type" class="form-control" required>
                </div>
              </div>   

              <div class="row form-group">
                <div class="col-3">
                <label class="label">ID VOucher</label>
                </div>
                <div class="col-9">
                  <input id="inp-id-voucher" class="form-control" required>
                </div>
              </div>   

              <div class="row form-group">
                <div class="col-3">
                <label class="label">Thành Tiền</label>
                </div>
                <div class="col-9">
                  <input id="inp-thanh-tien" class="form-control" required>
                </div>
              </div>  
              
              <div class="row form-group">
                <div class="col-3">
                <label class="label">Giảm giá</label>
                </div>
                <div class="col-9">
                  <input id="inp-giam-gia" class="form-control" required>
                </div>
              </div>  

              <div class="row form-group">
                <div class="col-3">
                <label class="label">Loại Nước Uống</label>
                </div>
                <div class="col-9">
                  <select id="slt-loai-nuoc" class="form-control">
                    <option value="PEPSI">PEPSI</option>
                    <option value="COCA">COCA</option>
                    <option value="TRATAC">TRÀ TẮC</option>
                    <option value="TRASUA">TRÀ SỮA</option>
                    <option value="LAVIE">NƯỚC LAVIE</option>
                  </select>
                </div>


              </div>
              
              <div class="row form-group">
                <div class="col-3">
                <label class="label">số lượng nước</label>
                </div>
                <div class="col-9">
                  <input type="number" id="inp-soluong-nuoc" class="form-control" required>
                </div>
              </div>  

              <div class="row form-group">
                <div class="col-3">
                <label class="label">Họ và tên</label>
                </div>
                <div class="col-9">
                  <input  id="inp-ho-ten" class="form-control" required>
                </div>
              </div>  

              <div class="row form-group">
                <div class="col-3">
                <label class="label">Email</label>
                </div>
                <div class="col-9">
                  <input type="email"  id="inp-email" class="form-control" required>
                </div>
              </div>  

              <div class="row form-group">
                <div class="col-3">
                <label class="label">Số Điện thoại</label>
                </div>
                <div class="col-9">
                  <input type="number"  id="inp-so-dienthoai" class="form-control" required>
                </div>
              </div>  

              <div class="row form-group">
                <div class="col-3">
                <label class="label">Địa chỉ</label>
                </div>
                <div class="col-9">
                  <input   id="inp-dia-chi" class="form-control" required>
                </div>
              </div>  

              <div class="row form-group">
                <div class="col-3">
                <label class="label">Lời nhắn</label>
                </div>
                <div class="col-9">
                  <input id="inp-loi-nhan" class="form-control" required>
                </div>
              </div> 
              
              <div class="row form-group">
                <div class="col-3">
                <label class="label">Ngày Order</label>
                </div>
                <div class="col-9">
                  <input id="inp-ngay-order" class="form-control" required>
                </div>
              </div>  

              <div class="row form-group">
                <div class="col-3">
                <label class="label">ngày chỉnh sửa</label>
                </div>
                <div class="col-9">
                  <input id="inp-ngay-chinhsua" class="form-control" required>
                </div>
              </div>  

            </div>
                 
                  
             
             <!-- modal footer  -->
             <div class="modal-footer bg-dark">
                 <button type="submit" id="btn-confirm" class="btn btn-primary"><i class="fas fa-plus ">&nbsp;</i>Confirmed</button>
               <button type="button" id="btn-cancel" class="btn btn-danger" >Cancel</button>
             </div>

           </div>
         </div>
        <!-- </form> -->
      </div>
 
</body>
<script>
    var gListUser;
    var gIdCurrent;
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_CREATE_OK = 201; // status 201 tao thanh cong
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    // base url API
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

    $(document).ready(function(){
       /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
       //creata a data for DataTable
       
       const gCOLUMN_ID = 0;
        const gCOLUMN_KICH_CO = 1;
        const gCOLUMN_LOAI_PIZZA = 2;
        const gCOLUMN_NUOC_UONG = 3;
        const gCOLUMN_THANH_TIEN = 4 ;
        const gCOLUMN_HO_TEN = 5;
        const gCOLUMN_SO_DIENTHOAI = 6;
        const gCOLUMN_TRANGTHAI = 7;
        const gCOLUMN_ACTION = 8;

        const gNAME_COL = ["id","duongKinh","loaiPizza","idLoaiNuocUong",
            "thanhTien","hoTen","soDienThoai","trangThai","Action"];
            
            // định nghĩa table  - chưa có data
            var gUserTable = $("#don-table").DataTable( {
            // Khai báo các cột của datatable
            "columns" : [
                { "data" : gNAME_COL[gCOLUMN_ID] },
                { "data" : gNAME_COL[gCOLUMN_KICH_CO] },
                { "data" : gNAME_COL[gCOLUMN_LOAI_PIZZA] },
                { "data" : gNAME_COL[gCOLUMN_NUOC_UONG] },
                { "data" : gNAME_COL[gCOLUMN_THANH_TIEN] },
                { "data" : gNAME_COL[gCOLUMN_HO_TEN] },
                { "data" : gNAME_COL[gCOLUMN_SO_DIENTHOAI] },
                { "data" : gNAME_COL[gCOLUMN_TRANGTHAI] },
                { "data" : gNAME_COL[gCOLUMN_ACTION] }
            ],
            // Ghi đè nội dung của cột action, chuyển thành button chi tiết
            "columnDefs": [ 
            {
                "targets": gCOLUMN_ACTION,
                "defaultContent": "<button class='info-user btn btn-info'>Chi tiết</button>"
            }]
            });
        onPageLoading();
       /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    //function on Button chi tiet click
    $("#don-table").on("click",".info-user",function(){
            console.log("xử lý chi tiết");
            var vCurrentInfo = getCurrentInfo(this);
            console.log(vCurrentInfo);
            $("#update-modal").modal("show");
            loadDataToModalUpdate(vCurrentInfo);
            gIdCurrent = vCurrentInfo.id;
       })

    //function on button Filter Click
    $("#btn-filter").on("click",function(){
        var vFilter = btnFilterClick()
        debugger;
        console.log(vFilter);
       loadDataToTable(vFilter);
    });
    
    //function confirm đơn hàng
    $("#btn-confirm").on("click",function(){
        // event.preventDefault();
        var vStatus = "confirmed";
        callAjaxToUpdate(vStatus);
        onPageLoading();
        $("#update-modal").modal("hide");
        
    })

    $("#btn-cancel").on("click",function(){
       
        var vStatus = "cancel";
        callAjaxToUpdate(vStatus);
        onPageLoading();
        $("#update-modal").modal("hide");
         
          
        console.log(gIdCurrent);
        
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
    //function on click filter
    function btnFilterClick(){
        var vResult = [];
        var vStatus = $("#slt-status").val();
        var PizzaType = $("#slt-pizza-type").val();
        var vResult = gListUser.filter(function(item){
            return (vStatus === item.trangThai || PizzaType === item.loaiPizza ||
            vStatus === 0 && PizzaType === 0);
        })

        return vResult;
    }
    
      
       //function load dataa for beginning
    function onPageLoading(){
        $.ajax({
        url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          //debugger;
          loadDataToTable(responseObject);
          gListUser = responseObject;
          console.log(gListUser);
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });
    }
       /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    
    function loadDataToTable(paramResponseObject) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      debugger;
      gUserTable.clear();
      //Cập nhật data cho bảng 
      gUserTable.rows.add(paramResponseObject);
      //Cập nhật lại giao diện hiển thị bảng
      gUserTable.draw();
    }
      //function get Current info on click button Chi tiet
      function getCurrentInfo(paraBtn){
        var vTrCurrent = $(paraBtn).closest("tr");
        var vTable = $("#don-table").DataTable();
        var vCurrentInfo = vTable.row(vTrCurrent).data();
        return vCurrentInfo;
    }

    //function load data to uupdate modal
    function loadDataToModalUpdate(paraObj){
      $("#inp-ordercode").val(paraObj.orderCode)
      $("#slt-size").val(paraObj.kichCo)
      $("#inp-duong-kinh").val(paraObj.duongKinh)
      $("#inp-suon").val(paraObj.suon)
      $("#inp-salad").val(paraObj.salad)

      $("#inp-pizza-type").val(paraObj.loaiPizza)
      $("#inp-id-voucher").val(paraObj.idVourcher)
      $("#inp-thanh-tien").val(paraObj.thanhTien)
      $("#inp-giam-gia").val(paraObj.giamGia)
      $("#slt-loai-nuoc").val(paraObj.idLoaiNuocUong)

      $("#inp-soluong-nuoc").val(paraObj.soLuongNuoc)
      $("#inp-ho-ten").val(paraObj.hoTen)
      $("#inp-email").val(paraObj.email)
      $("#inp-so-dienthoai").val(paraObj.soDienThoai)
      $("#inp-dia-chi").val(paraObj.diaChi)

      $("#inp-loi-nhan").val(paraObj.loiNhan)
      $("#inp-ngay-order").val(paraObj.ngayTao)
      $("#inp-ngay-chinhsua").val(paraObj.ngayCapNhat)




      

    }
    //function update don hang
  function callAjaxToUpdate(paraStatus){
    var vId = gIdCurrent;   // đây là Id của order, KHÔNG phải orderCode
        var vObjectRequest = {
            trangThai: paraStatus // 3: trang thai open, confirmed, cancel tùy tình huống
        }

        var vXmlHttpUpdateOrder = new XMLHttpRequest();
        vXmlHttpUpdateOrder.open("PUT", gBASE_URL + "/" + vId);
        vXmlHttpUpdateOrder.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        vXmlHttpUpdateOrder.send(JSON.stringify(vObjectRequest));
        vXmlHttpUpdateOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vUpdatedOrder = vXmlHttpUpdateOrder.responseText;
                    console.log(vUpdatedOrder);
                    
                }
            }
  }



})


</script>
</html>